#ifndef		_ReaperH
#define		_ReaperH	TRUE




enum ReaperIDs
 {
	igsReaper			= 'Rep'
 };


enum ReaperPrefVers
 {
	kvrReaper1			= 0x0100,

	kvrReaperMinCompat	= kvrReaper1,
	kvrReaperCurrent	= kvrReaper1
 };



typedef struct BadAppRec		BadApp, * badApp, ** BADAPP;
typedef struct AppItemRec		AppItem, * appItem, ** APPITEM;

enum BadAppItemFlags
 {
	bbaFixFCB				= (1 << 6),		// Allow read access to LMGetFCBSPtr()
	bbaRun68K				= (1 << 5),		// Give errResNotFound on 'cfrg' when launched
	bbaLimitHeap			= (1 << 4),		// Limit temp allocation to double app heap size (HP PrintMonitor)
	bbaSmartHeap			= (1 << 3),		// Allocate handles > 1/8th of heap size in temp mem
	bbaExpand				= (1 << 2),		// Expand heap with temp mem
	bbaByName				= (1 << 1),		// Recognize by name
	bbaOnlyIfROM			= (1 << 0)		// Only if from Read-Only Volume
 };

enum BadAppFlags
 {
	bapUnused				= (1 << 0)
 };

#pragma options align=mac68k

struct AppItemRec
 {
	OSType		creator;
	short		reap;		// < 0 = % to increase, > 0 = 16 KBs to increase
	flag16		flags;		// Turn these on
 };

struct BadAppRec
 {
	word		version;
	short		reapROM;	// Default for read-only
	ident		id;			// igsReaper
	short		reapRWM;	// Default for all others
	short		cnt;
	AppItem		item[1];
	// Followed by SLUT of item names
 };

#define	mcPrefSlutOffset(ba)	((sizeof(BadApp) - sizeof(AppItem)) + ((ba)->cnt * sizeof(AppItem)))
#define	mcPrefSlut(ba)			mcPrefSlutX((ba)->item, (ba)->cnt)
#define	mcPrefSlutX(i, n)		((slut)((Ptr)(i) + ((n) * sizeof(AppItem))))

#pragma options align=reset





typedef struct ReaperGloRec	ReaperGlo, * reaperGlo, ** REAPERGLO;


enum ReaperGloBits
 {
	brpIsLaunchingBit		= 0,
	brpInOpenPictureBit
 };


enum ReaperGloFlags
 {
	brpInOpenPicture	= (1 << brpInOpenPictureBit),
	brpIsLaunching		= (1 << brpIsLaunchingBit)
 };


#pragma options align=mac68k

struct ReaperGloRec
 {
	ident		id;			// = igsReaper
	word		version;
	flag16		flags;		// brp flags
	BADAPP		prefs;		// Other app infos
	THz			tmpZone;	// Zone of temporary memory
 };

#pragma options align=reset



#include	"Reaper Utils.proto.h"


#endif	//	Already included
