
#ifndef		_yLibCfgH
#define		_yLibCfgH			TRUE

/****************************************************************************************************\

	File:		yLibCfg.h

	Version:	1.28

	Contains:	AxON Configuration (Modules in or out)

	Written by:	Gregory Mathias Lemperle-Kerr

	Copyright:	1992-1998 by AKUA interactive media AG. All rights reserved.

	Usage:		Configuration of AKUA's Library Agencies

	To Do:		

	History
	----------------------------------------------------------------------------------------------------
	Ver	Who	When		What
	---	---	----------	--------------------------------------------------------------------------------
	128	GOD	19.12.1996	Add Y_TONGUES for international language support through the Bond Agency

	127	GOD	07.12.1996	Add Y_HYPERCARD for the AxON Agency XCMD/XFCN support

	126	GOD	07.12.1996	Add Y_MUZAK for the Muzak Agency

	125	GOD	08.09.1996	Add Y_DRAGFOLDER to toggle support for dropping of HFS folders

	124	GOD	14.08.1996	Add Y_NOTEMPMEM for things that get mem when TempMem is not initted.

	123	GOD	08.08.1996	Added pre-init of Effect manager using Y_EFFECT. This is also not necessary to
						 use the Effect Agency, just to speed up effects by allowing pre-loading of
						 COPY agents.

	122	GOD	07.08.1996	Added pre-init of Talk manager using Y_TALK. This is not necessary to USE the
						 Talk Agency, just to init it when starting up.

	121	GOD	28.07.1996	Add Y_WNDCAST_CREATE for creation of DLUTs.
						Add Y_BOND_DUMP for dumping of CoSt resources into a BOND file.

	120	GOD	22.07.1996	Y_PRINTGX was missing in imported file.

	119	GOD	22.07.1996	Damn Y_PICTLABEL was still in imported file. Changed to Y_LAYOUT

	118	GOD	17.07.1996	Bring in NORAWPORT as Y_NORAWPORT to prohibit creation of a raw CGrafPort
						 in dpRaw routines.
						Added Y_INDEX since this was needed but not included...

	117	GOD	08.07.1996	Add Y_JURY to include ability to ask user his opinion. Requires Y_BOND.

	116	GOD	07.07.1996	Add Y_WNDCAST_CHECKS to check validity of 'ictb' and 'DLUT' resources
						 since Resorcerer fucks them up quite often

	115	GOD	24.06.1996	All options changed to TRUE/FALSE from just #define, so they can
						 not be forgotten.

	114	GOD	24.06.1996	Added Y_KNOT and Y_KN_CACHE for the Knot Agency.
						Begin changing #define xxx to #define xxx 1 or 0

	102-113	GOD			Lots of changes noted below

	101	GOD	23.09.1994	Integration of STANDALONE, CONVERT, PANEL and UPDATE

	100	GOD	15.04.1994	Start with AxON, NET, FILEELEM, VESSEL
	----------------------------------------------------------------------------------------------------

\****************************************************************************************************/

// For Code Resources
#define		STANDALONE			TRUE
#define		SHAREDQD			FALSE


// AxON Integration (yAxon Files)
#define		Y_AxON				FALSE
#define		Y_AxONEDIT			FALSE


// Bond Agency (yBond.c) for string & value tables
#define		Y_BOND				FALSE


// Conversion Integration (yConvert)
#define		Y_CONVERT			FALSE


// Drag & Drop Integration (yDrag)
#define		Y_DRAG				FALSE
#define		Y_DRAGFOLDER		FALSE


// Effect Integration (yEffect)
#define		Y_EFFECT			FALSE


// FileElement Integration (yFile Partial)
#define		Y_FILEELEM			FALSE


// Copy Protection Integration (yGuard)
#define		Y_GUARD				FALSE


// HyperCard Support (yAxon) for XCMD/XFCN calls
#define		Y_HYPERCARD			FALSE


// Index Agency (yIndex) for dynamic linking and agent overrides
#define		Y_INDEX				FALSE


// Jury Agency (yJury) for asking the user his opinion
#define		Y_JURY				FALSE


// Knot Agency for storing tagged blocks of data together
#define		Y_KNOT				FALSE
#define		Y_KN_CACHE			FALSE		// Should Knot Agency be able to handle cached Knots?


// Layout Agency Integration (yPict Partial)
#define		Y_LAYOUT			FALSE


// Muzak Agency Integration (yMuzak)
#define		Y_MUZAK				FALSE


// CommToolBox Integration (yNet)
#define		Y_NET				FALSE


// Panel Integration (Dialog Panels)
#define		Y_PANEL				FALSE


// Printing Integration (yPrint)
#define		Y_PRINT				FALSE
#define		Y_PRINTGX			FALSE


// QuickTime Integration (yVessel, yCompress, yGrip)
#define		Y_COMPRESS			FALSE	// Image Compression
#define		Y_GRIP				FALSE	// Video Input & Audio Input through QuickTime
#define		Y_VESSEL			FALSE	// Movie Toolbox


// TextToSpeach Integration (yTalk)
#define		Y_TALK				TRUE


// International Support Integration (yBond, yMenu, yWndObj etc.)
#define		Y_TONGUES			FALSE


// Update Integration (yUpdate)
#define		Y_UPDATE			FALSE


// Window Cast (yWndCast) and Window Text (yWndTxt)
#define		Y_WNDCAST			FALSE
#define		Y_WNDCAST_CHECKS	FALSE	// Check validity of 'ictb' and 'DLUT' resources - since Resorcerer fucks them up quite often
#define		Y_WNDCAST_CREATE	FALSE	// Create Casts from DITLs if possible and necessary
#define		Y_WNDTEXT			FALSE
#define		Y_WNDTEXTPATS		FALSE


// X-Tend Agency (yXtend) for plug-ins
#define		Y_XTEND				FALSE


// Internal options off
#define		Y_NOBLACKANDWHITE	FALSE	// No support for non-colourQD machines
#define		Y_NOCOLOUR			FALSE	// No support for colour quickdraw
#define		Y_NODISPATCH		FALSE	// No Internal Event Dispatch (Standalone.c)
#define		Y_NORAWPORT			TRUE	// No support for drawing to our own raw port
#define		Y_NOTEMPMEM			FALSE	// No grabbing TempMem if we ain't got enough.


enum Generics
 {
	kalGeneric		= 128
 };


// Specific to AlertTimex
#define		INITUSAGE			TRUE	// Going to be installed at init time - no app recording

#endif		// Already included
